SoVertexProperty(3)

NAME
SoVertexProperty - The SoVertexProperty class collects the functionality of various appearance nodes.

SYNOPSIS

#include <Inventor/nodes/SoVertexProperty.h>

Inherits SoNode.

  Public Types
enum Binding { OVERALL = 2, PER_PART, PER_PART_INDEXED, PER_FACE, PER_FACE_INDEXED, PER_VERTEX, PER_VERTEX_INDEXED }
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }

  Public Member Functions
virtual SoType getTypeId (void) const
SoVertexProperty (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual SbBool affectsState (void) const
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void handleEvent (SoHandleEventAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void search (SoSearchAction *action)
virtual void write (SoWriteAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
SbUniqueId getNodeId (void) const
virtual SoChildList * getChildren (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual void copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoMFVec3f vertex
SoMFVec2f texCoord
SoMFVec3f texCoord3
SoMFVec3f normal
SoSFEnum normalBinding
SoMFUInt32 orderedRGBA
SoSFEnum materialBinding
SoMFInt32 textureUnit

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVertexProperty ()
virtual void notify (SoNotList *list)
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const
virtual SoNotRec createNotRec (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoVertexProperty class collects the functionality of various appearance nodes. Instead of reading data from the current state stack of the scene graph traversal, nodes inheriting SoVertexShape can be set up with an SoVertexProperty node in the SoVertexShape::vertexProperty field. Coordinates, normals, texture coordinates and material / color information will then be fetched from the vertex shape's SoVertexProperty node instead of from the state stack.

The SoVertexProperty node provides fields for duplicating the functionality of all these other Inventor node types: SoCoordinate3, SoTextureCoordinate2, SoTextureCoordinate3, SoNormal, SoPackedColor, SoMaterialBinding and SoNormalBinding.

The SoVertexProperty node was introduced fairly late in the design of the Inventor API by SGI. The idea behind it was to provide a means to specify the necessary data for vertex shape derived nodes which would be more efficient to work with than fetching the data from the traversal state stack.

In practice, the effect is not at all very noticeable. Since the use of SoVertexProperty nodes in the SoVertexShape::vertexProperty field somewhat breaks with the basic design of the Open Inventor API (the SoVertexProperty data is not pushed to the traversal state stack), you might be better off design-wise by using the usual mechanisms, i.e. by setting up the individual nodes SoVertexProperty "collects".

One of the drawbacks will for instance be that it is not possible to share parts of the SoVertexProperty node between several shapes, which is something that can easily be done when setting up individual state changing nodes in the scene graph.

FILE FORMAT/DEFAULTS:

VertexProperty {
    vertex [  ]
    normal [  ]
    texCoord [  ]
    orderedRGBA [  ]
    texCoord3 [  ]
    normalBinding PER_VERTEX_INDEXED
    materialBinding OVERALL
}

Since
    SGI Inventor 2.1

See also
    SoVertexShape

    SoCoordinate3, SoTextureCoordinate2, SoTextureCoordinate3, SoNormal

    SoPackedColor

    SoMaterialBinding, SoNormalBinding

Member Enumeration Documentation

  enum SoVertexProperty::Binding
The binding types available for our SoVertexProperty::normalBinding and SoVertexProperty::materialBinding fields.

For a detailed explanation of each of the enumeration value binding types, see the documentation of the SoMaterialBinding node.

Constructor & Destructor Documentation

  SoVertexProperty::SoVertexProperty (void )
Constructor.

  SoVertexProperty::~SoVertexProperty () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVertexProperty::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVertexProperty::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

  const SoFieldData ** SoVertexProperty::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVertexProperty::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoVertexProperty::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoVertexProperty::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoVertexProperty::getBoundingBox (SoGetBoundingBoxAction * action) [virtual]
Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculate their bounding box also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoVertexProperty::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoVertexProperty::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoVertexProperty::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

  void SoVertexProperty::notify (SoNotList * l) [protected], [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

Member Data Documentation

  SoMFVec3f SoVertexProperty::vertex
This field sets up vertex coordinates in the same manner as SoCoordinate3::point.

By default the field contains no coordinates.

See also
    SoCoordinate3

  SoMFVec2f SoVertexProperty::texCoord
Same functionality as SoTextureCoordinate2::point. By default the field contains no coordinates.

See also
    SoTextureCoordinate2

  SoMFVec3f SoVertexProperty::texCoord3
Same functionality as SoTextureCoordinate3::point. By default the field contains no coordinates.

See also
    SoTextureCoordinate3

Since
    Coin 2.0

    TGS Inventor 2.6

  SoMFVec3f SoVertexProperty::normal
This field defines a set of normal vectors in the same manner as SoNormal::vector. By default the field contains no vectors.

See also
    SoNormal

  SoSFEnum SoVertexProperty::normalBinding
Defines how to bind the normals specified in the SoVertexProperty::normal set to the parts of the "owner" shape. Must be one of the values in the SoVertexProperty::Binding enum.

Default value of the field is SoVertexProperty::PER_VERTEX_INDEXED.

See also
    SoNormalBinding

  SoMFUInt32 SoVertexProperty::orderedRGBA
A set of "packed" 32-bit diffuse color plus transparency values. Works in the same manner as the SoPackedColor::orderedRGBA field.

By default the field has no data.

See also
    SoPackedColor

  SoSFEnum SoVertexProperty::materialBinding
Defines how to bind the color values specified in the SoVertexProperty::orderedRGBA set to the parts of the "owner" shape. Must be one of the values in the SoVertexProperty::Binding enum.

Default value of the field is SoVertexProperty::OVERALL.

See also
    SoMaterialBinding

  SoMFInt32 SoVertexProperty::textureUnit
The texture unit(s) for the texture coordinates. By default this field contains one value, 0, and texture coordinates are then sent to texture unit 0. It's possible to supply multiple values in this field, and the texture coordinates in texCoord or texCoord3 will then be split into those units. The first totalnum/numunits coordinates will be sent to the first unit specified, the next totalnum/numunits coordinates will be sent to the second unit in this field, etc.

See also
    SoTextureCoordinate2, SoTextureUnit

Since
    Coin 4.0

Author

Generated automatically by Doxygen for Coin from the source code.